Uses Crt,Dos;
TYPE SetOfChar=SET OF CHAR;
CONST Alphabet: SetOfChar=['A'..'Z','a'..'z'];
      NoChar=#0;
      MaxLetters=120;
VAR Uncapitalize: BOOLEAN;
    CodeOf: ARRAY[#0..#255] OF INTEGER;
    LetterNo: ARRAY[1..MaxLetters] OF CHAR;
    Fq,FqInitial,FqMedial,FqFinal,FqAlone,FqLineInitial,FqLineFinal,
    Vowel: ARRAY[1..MaxLetters] OF INTEGER;
    Cell: ARRAY[1..MaxLetters,1..MaxLetters] OF INTEGER;
    LastLetter: INTEGER; c: CHAR;
    SumAll,SumInitial,SumFinal,SumMedial,SumAlone,SumLi,SumLineFinal,
    Vowels: INTEGER;


FUNCTION NameOf(VAR f: TEXT): STRING;
VAR i: INTEGER;
BEGIN i:=1;
  WITH TextRec(f) DO
  WHILE Name[i]>' ' DO Inc(i);
  NameOf:=Copy(TextRec(f).Name,1,i)
END;

FUNCTION UnCaps(s: string): string; VAR i: INTEGER; c: CHAR;
(* Returns a string all in lowercase *)

BEGIN FOR i:=1 TO Length(s) DO
  BEGIN c:=s[i]; IF (c>='A') AND (c<='Z') THEN s[i]:=CHR(ORD(c)+32)
  END;
  UnCaps:=s
END;

PROCEDURE Zero;
BEGIN
    FillChar(CodeOf,SizeOf(CodeOf),0);
    FillChar(LetterNo,SizeOf(LetterNo),0);
    FillChar(Fq,SizeOf(Fq),0);
    FillChar(FqInitial,SizeOf(FqInitial),0);
    FillChar(FqMedial,SizeOf(FqMedial),0);
    FillChar(FqFinal,SizeOf(FqFinal),0);
    FillChar(FqAlone,SizeOf(FqAlone),0);
    FillChar(FqLineInitial,SizeOf(FqLineInitial),0);
    FillChar(FqLineFinal,SizeOf(FqLineFinal),0);
    FillChar(Vowel,SizeOf(Vowel),0);
    FillChar(Cell,SizeOf(Cell),0);
    LastLetter:=0;
    SumAll:=0;
    SumInitial:=0;
    SumFinal:=0;
    SumMedial:=0;
    SumAlone:=0;
    SumLi:=0;
    SumLineFinal:=0;
    Vowels:=0;
END;



PROCEDURE CountThem(VAR f: TEXT; VAR n: INTEGER);
(* carries out frequency counts of the letters in file f,
   returns number of different letters as n.
   The frequencies with which letters occur next to
   each other is recorded in array Cell.
*)

VAR s: string;
    i,k,PreviousLetter,LastChar,SecondLastChar,EndOfLine: INTEGER;
    c: CHAR;
    GotIt: BOOLEAN;
BEGIN PreviousLetter:=0;
  reset(f);
  WHILE NOT Eof(f) DO
  BEGIN Readln(f,s);
    IF s<>'' THEN IF s[1]<>';' {which shows a comment} THEN
    BEGIN
    IF Uncapitalize THEN s:=UnCaps(s); s:=s+' ';
    LastChar:=0; SecondLastChar:=0;
    FOR i:=1 TO Length(s) DO
    BEGIN c:=s[i];
      IF c IN Alphabet THEN
      BEGIN
        IF CodeOf[c]=0 THEN
        BEGIN inc(n); CodeOf[c]:=n; LetterNo[n]:=c;
        END;
        k:=CodeOf[c]; Fq[k]:=Fq[k]+1;
        IF PreviousLetter<>0 THEN
        (*** update array Cell, later used to identify vowels ***)
        BEGIN Cell[k,PreviousLetter]:=Cell[k,PreviousLetter]+1;
          Cell[PreviousLetter,k]:=Cell[PreviousLetter,k]+1;
        END;
        PreviousLetter:=k
      END;
      IF c IN Alphabet THEN
      BEGIN
        IF LastChar=0 THEN
        BEGIN FqInitial[k]:=FqInitial[k]+1
        END;
        SecondLastChar:=LastChar;
        LastChar:=k;
      END
      ELSE
      BEGIN
         IF LastChar<>0 THEN
         BEGIN
           IF SecondLastChar<>0 THEN FqFinal[LastChar]:=FqFinal[LastChar]+1
           ELSE
           BEGIN FqAlone[LastChar]:=FqAlone[LastChar]+1;
                 FqInitial[LastChar]:=FqInitial[LastChar]-1
           END
         END;
         SecondLastChar:=LastChar;
         LastChar:=0
      END
    END;
    EndOfLine:=Length(s);
    i:=0; GotIt:=false;
    REPEAT i:=i+1;
      c:=s[i];
      IF c IN Alphabet THEN
      BEGIN k:=CodeOf[c]; FqLineInitial[k]:=FqLineInitial[k]+1;
        GotIt:=true
      END
    UNTIL GotIt OR (i=EndOfLine);
    i:=EndOfLine; GotIt:=false;
    REPEAT i:=i-1;
      c:=s[i];
      IF c IN Alphabet THEN
      BEGIN k:=CodeOf[c]; FqLineFinal[k]:=FqLineFinal[k]+1;
        GotIt:=true
      END
    UNTIL GotIt OR (i=1);
    END;
  END;
  Close(f)
END;




PROCEDURE Sort;
(* Shell sort. Sorts letters in order of decreasing frequencies *)

VAR i,j,k,m,tmp,n: INTEGER; swap: BOOLEAN; c: CHAR;
BEGIN n:=LastLetter;
  m:=1; WHILE m<=n DO m:=m+m; m:=(m-1) DIV 2;
  WHILE m>0 DO
  BEGIN FOR j:=1 TO n-m DO
    BEGIN i:=j; k:=i+m;
      REPEAT swap:=Fq[k]>Fq[i];
        IF swap
        THEN BEGIN
           tmp:=Fq[k]; Fq[k]:=Fq[i]; Fq[i]:=tmp;
           tmp:=FqInitial[k]; FqInitial[k]:=FqInitial[i]; FqInitial[i]:=tmp;
           tmp:=FqFinal[k]; FqFinal[k]:=FqFinal[i]; FqFinal[i]:=tmp;
           tmp:=FqAlone[k]; FqAlone[k]:=FqAlone[i]; FqAlone[i]:=tmp;
           tmp:=FqLineFinal[k]; FqLineFinal[k]:=FqLineFinal[i]; FqLineFinal[i]:=tmp;
           tmp:=FqLineInitial[k]; FqLineInitial[k]:=FqLineInitial[i]; FqLineInitial[i]:=tmp;
           tmp:=Vowel[k]; Vowel[k]:=Vowel[i]; Vowel[i]:=tmp;
           c:=LetterNo[k]; LetterNo[k]:=LetterNo[i]; LetterNo[i]:=c;
           i:=i-m; k:=i+m;
        END
      UNTIL (i<=0) OR NOT swap
    END;
    m:=m DIV 2
  END;
END;

PROCEDURE Calculate;
(* Sums frequencies *)
VAR i,n,
      FqAll,FqFin,FqInit,FqMed,FqLone,FqLI,FqLF: INTEGER;
BEGIN n:=LastLetter;
    for i:=1 to n do
    begin FqAll:=Fq[i]; FqInit:=FqInitial[i]; FqFin:=FqFinal[i];
        FqLone:=FqAlone[i];
        FqMed:=FqAll-FqInit-FqFin-FqLone;
        FqMedial[i]:=FqMed;
        SumAll:=SumAll+FqAll;
        SumInitial:=SumInitial+FqInit;
        SumFinal:=SumFinal+FqFin;
        SumMedial:=SumMedial+FqMed;
        SumAlone:=SumAlone+FqLone;
        SumLi:=SumLi+FqLineInitial[i];
        SumLineFinal:=SumLineFinal+FqLineFinal[i];
        if Vowel[i]>0 then Vowels:=Vowels+1;
    end
END;



{***** Sukhotin's vowel recognition algorithm

(1) Fill main diagonal of array Cell with zeroes.
(2) Let Sum(i) be the sum of the entries of the ith row.
    Calculate Sum(i) for each row.
(3) Let Cat(i) be the category (vowel or consonant) of letter i.
    Set all letters to consonant, (i.e. for i:=1 to n do Cat(i):=consonant).
(4) Select the letter m for which Sum(m) is maximum and Cat(i) is
    consonant.
    If Sum(m)> 0 then
       a) set Cat(m) to vowel,
       b) let Sum(i) = Sum(i)- f(i,m)*2 for all i's for which Cat(i)
          is consonant.
    Repeat until Sum(m)=0.
*****}
PROCEDURE FindVowels;
  VAR x,y,n, max,sum,ymax,ThisVowel: INTEGER; Stop: BOOLEAN;
  SumOf: ARRAY[1..MaxLetters] OF INTEGER;
BEGIN ThisVowel:=0;
  n:=LastLetter;
  FOR x:=1 TO n DO Cell[x,x]:=0;
  FOR y:=1 TO n DO
  BEGIN Sum:=0;
    FOR x:=1 TO n DO Sum:=Sum+Cell[y,x];
    SumOf[y]:=Sum
  END;
  REPEAT  max:=0;
    FOR y:=1 TO n DO IF (Vowel[y]=0) AND (SumOf[y]>max)
    THEN BEGIN ymax:=y; max:=SumOf[y] END;
    Stop:=max<=1;
    IF NOT Stop
    THEN BEGIN ThisVowel:=ThisVowel+1;
      Vowel[ymax]:=ThisVowel;
      FOR y:=1 TO n DO IF (Vowel[y]=0)
      THEN SumOf[y]:=SumOf[y]-Cell[ymax,y]-Cell[y,ymax];
    END
  UNTIL Stop
END;


FUNCTION Yes(Prompt: STRING): BOOLEAN; VAR c: CHAR;
(* prompts a question and waits until you press Y or N
   in answer. Returns TRUE if you answered Y, FALSE if
   you answered N *)

BEGIN Write(Prompt);
   REPEAT c:=ReadKey; c:=Upcase(c) UNTIL c IN ['Y','N'];
   Yes:=c='Y';
END;


PROCEDURE wait; VAR c: CHAR;
(* Asks you to press a key, any key, to continue *)
BEGIN GotoXY(1,24);
   write('Press any key to continue '); c:=ReadKey;
   if Keypressed then c:=ReadKey;
END;


FUNCTION GetFile(x,y: BYTE; Prompt: STRING; VAR f: TEXT): BOOLEAN;
(* the first character of the prompt must be         *)
(* 'i' or 'I' for an input file                      *)
(* 'o' or 'O' for an output file                     *)
VAR fn: string; ok,found: BOOLEAN;
BEGIN GetFile:=FALSE; fn:=''; Reset(input);
  REPEAT Gotoxy(x,y); ClrEol; write(Prompt); read(fn);
    IF fn='' THEN Exit;
    Assign(f,fn); {$I-} Reset(f) {$I+}; found:=IOResult=0;
    CASE Prompt[1] OF
      'i','I': {Input}
             IF found THEN ok:=TRUE
             ELSE BEGIN ok:=FALSE; Gotoxy(x,y); ClrEol;
                write(fn+' not found. '+Prompt);
             END;
      'o','O': {Output}
             IF found
             THEN BEGIN Gotoxy(x,y); ClrEol;
                    ok:=Yes('Overwrite '+fn+'? (Y/N) ');
                  END
             ELSE ok:=TRUE;
    END
  UNTIL ok;
  GetFile:=ok;
END;


PROCEDURE CapitalizeOrNot; VAR c: CHAR;
BEGIN
  Uncapitalize:=Yes('Change all uppercase to lowercase? (Y/N) '); writeln;
END;

PROCEDURE GetAlphabet;
VAR ChangeIt: BOOLEAN; Buffer: STRING[80]; c: CHAR; i: INTEGER;
BEGIN
  REPEAT writeln('Alphabet is now:');
    FOR c:=#33 TO #126 DO IF c IN Alphabet THEN write(c);
    writeln;
    ChangeIt:=Yes('Any changes? (Y/N) '); writeln;
    IF ChangeIt THEN
    BEGIN write('Remove: '); readln(buffer);
      FOR i:=1 TO Length(buffer) DO
      BEGIN c:=buffer[i]; Alphabet:=Alphabet-[c]
      END;
      IF buffer<>'' THEN
      BEGIN writeln('Alphabet is now:');
        FOR c:=#33 TO #126 DO IF c IN Alphabet THEN write(c); writeln;
      END;
      write('Add: '); readln(buffer);
      FOR i:=1 TO Length(buffer) DO
      BEGIN c:=buffer[i];
        IF (c>' ') AND (c<=#126) THEN Alphabet:=Alphabet+[c]
      END
    END
  UNTIL NOT ChangeIt
END;
PROCEDURE ClearSums;
BEGIN
  LastLetter:=0;
  FillChar(CodeOf,SizeOf(CodeOf),0);
  FillChar(Fq,SizeOf(Fq),0);
  FillChar(FqInitial,SizeOf(FqInitial),0);
  FillChar(FqFinal,SizeOf(FqFinal),0);
  FillChar(FqAlone,SizeOf(FqAlone),0);
  FillChar(FqLineInitial,SizeOf(FqLineInitial),0);
  FillChar(FqLineFinal,SizeOf(FqLineFinal),0);
  FillChar(Cell,SizeOf(Cell),0);
END;

PROCEDURE Title(VAR f: TEXT);
BEGIN
    writeln(f,SumAll,' letters. ',Vowels,' vowels, ',LastLetter-Vowels,' consonants');
    writeln(f);
    writeln(f,
    '        Absolute frequency                 Relative Frequency (per 1000)');
    writeln(f,
'V#  Total Init  Med  Fin Isol  L/I  L/F    Total Init  Med  Fin Isol  L/I  L/F');
END;

PROCEDURE ShowLetterNo(VAR f: TEXT; i: INTEGER);
 FUNCTION RelFrq(n,Sum: INTEGER): INTEGER;
 BEGIN IF Sum=0 THEN RelFrq:=0 ELSE
       RelFrq:=Round(n/Sum*1000)
 END;
BEGIN
    IF Vowel[i]=0 THEN write(f,'  ') ELSE write(f,Vowel[i]:2);
    write(f,LetterNo[i]:2);
    writeln(f,Fq[i]:5,
          FqInitial[i]:5,
          FqMedial[i]:5,
          FqFinal[i]:5,
          FqAlone[i]:5,
          FqLineInitial[i]:5,
          FqLineFinal[i]:5,
          LetterNo[i]:4,
          RelFrq(Fq[i],SumAll):5,
          RelFrq(FqInitial[i],SumInitial):5,
          RelFrq(FqMedial[i],SumMedial):5,
          RelFrq(FqFinal[i],SumFinal):5,
          RelFrq(FqAlone[i],SumAlone):5,
          RelFrq(FqLineInitial[i],SumLi):5,
          RelFrq(FqLineFinal[i],SumLineFinal):5
          );
END;

PROCEDURE ShowResults(n: INTEGER);
CONST BottomRow=22;
VAR i,y: INTEGER;
BEGIN
  REPEAT i:=0;
    REPEAT ClrScr; Title(output); y:=4;
      REPEAT Inc(i); Inc(y); ShowLetterNo(output,i);
      UNTIL (y=BottomRow) OR (i=n);
      IF i<n THEN
      BEGIN GotoXY(1,24); write('--- There is more  (press any key) ---');
        REPEAT UNTIL KeyPressed;
      END;
    UNTIL i=n;
    GotoXY(1,24); ClrEol;
  UNTIL NOT Yes('Display table again? (Y/N) ');
END;

PROCEDURE FileResults(VAR f: TEXT);
VAR i: INTEGER;
BEGIN
   rewrite(f); Title(f);
   FOR i:=1 TO LastLetter do ShowLetterNo(f,i);
   close(f);
END;

VAR infile,outfile: TEXT;
BEGIN
  REPEAT ClearSums; ClrScr;
    GetAlphabet;  CapitalizeOrNot;
    WHILE GetFile(1,24,'Input text from file: ',infile) DO
    BEGIN Zero;
      CountThem(infile,LastLetter);
      FindVowels;
      Sort;
      Calculate;
      Title(output);
      ShowResults(LastLetter);
      IF GetFile(1,24,'Output statistics of '+nameOf(infile)+' to file: ',outfile)
      THEN FileResults(outfile);
    END;
    GotoXY(1,25);
  UNTIL NOT Yes('Redefine alphabet? (Y/N) ')
END.
